<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import {
  exportSysLogLogin,
  listSysLogLogin,
  delSysLogLogin,
  cleanSysLogLogin,
  unlock,
} from '@/api/system/log/login';
import { saveAs } from 'file-saver';
import { parseDateToStr } from '@/utils/date-utils';
import useDictStore from '@/store/modules/dict';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
const { t } = useI18n();
const { getDict } = useDictStore();

/**字典数据 */
let dict: {
  /**登录状态 */
  sysCommonStatus: DictType[];
} = reactive({
  sysCommonStatus: [],
});

/**开始结束时间 */
let queryRangePicker = ref<[string, string]>(['', '']);

/**查询参数 */
let queryParams = reactive({
  /**登录地址 */
  ipaddr: '',
  /**登录账号 */
  userName: '',
  /**登录状态 */
  status: undefined,
  /**开始时间 */
  beginTime: '',
  /**结束时间 */
  endTime: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    ipaddr: '',
    userName: '',
    status: undefined,
    beginTime: '',
    endTime: '',
    pageNum: 1,
    pageSize: 20,
  });
  queryRangePicker.value = ['', ''];
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
  /**勾选单个的登录账号 */
  selectedUserName: string;
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
  selectedRowKeys: [],
  selectedUserName: '',
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.system.log.login.operId'),
    dataIndex: 'loginId',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.system.log.login.account'),
    dataIndex: 'userName',
    align: 'left',
    width: 150,
  },
  {
    title: t('views.system.log.login.loginIp'),
    dataIndex: 'ipaddr',
    align: 'left',
    width: 150,
  },
  // {
  //   title: t('views.system.log.login.loginLoc'),
  //   dataIndex: 'loginLocation',
  //   align: 'left',
  //   width: 150,
  // },
  {
    title: t('views.system.log.login.os'),
    dataIndex: 'os',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.system.log.login.browser'),
    dataIndex: 'browser',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.system.log.login.status'),
    dataIndex: 'status',
    key: 'status',
    align: 'center',
    width: 100,
  },
  {
    title: t('views.system.log.login.loginTime'),
    dataIndex: 'loginTime',
    align: 'center',
    width: 200,
    customRender(opt) {
      if (+opt.value <= 0) return '';
      return parseDateToStr(+opt.value);
    },
  },
  {
    title: t('views.system.log.login.info'),
    dataIndex: 'msg',
    align: 'left',
    width: 200,
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRows(
  _: (string | number)[],
  rows: Record<string, string>[]
) {
  tableState.selectedRowKeys = rows.map(item => item.loginId);
  // 针对单个登录账号解锁
  if (rows.length === 1) {
    tableState.selectedUserName = rows[0].userName;
  } else {
    tableState.selectedUserName = '';
  }
}

/**记录删除 */
function fnRecordDelete() {
  const ids = tableState.selectedRowKeys.join(',');
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.log.login.delSure', { ids }),
    onOk() {
      const key = 'delSysLogLogin';
      message.loading({ content: t('common.loading'), key });
      delSysLogLogin(ids).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', { msg: t('common.deleteText') }),
            key,
            duration: 3,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 3,
          });
        }
        fnGetList();
      });
    },
  });
}

/**列表清空 */
function fnCleanList() {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.log.login.delAllSure'),
    onOk() {
      const key = 'cleanSysLogLogin';
      message.loading({ content: t('common.loading'), key });
      cleanSysLogLogin().then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: t('views.system.log.login.delAll'),
            }),
            key,
            duration: 3,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 3,
          });
        }
        fnGetList();
      });
    },
  });
}

/**登录账号解锁 */
function fnUnlock() {
  const username = tableState.selectedUserName;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.log.login.unlockSure', { username }),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      unlock(username).then(res => {
        hide();
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.system.log.login.unlockSure', {
              userName: username,
            }),
            duration: 3,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            duration: 3,
          });
        }
      });
    },
  });
}

/**列表导出 */
function fnExportList() {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.user.exportSure'),
    onOk() {
      const key = 'exportSysLogLogin';
      message.loading({ content: t('common.loading'), key });
      exportSysLogLogin(toRaw(queryParams)).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: t('views.system.user.export'),
            }),
            key,
            duration: 2,
          });
          saveAs(res.data, `sys_log_login_${Date.now()}.xlsx`);
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**查询登录日志列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  if (!queryRangePicker.value) {
    queryRangePicker.value = ['', ''];
  }
  queryParams.beginTime = queryRangePicker.value[0];
  queryParams.endTime = queryRangePicker.value[1];
  listSysLogLogin(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('sys_common_status')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.sysCommonStatus = resArr[0].value;
    }
  });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.log.login.loginIp')"
              name="ipaddr"
            >
              <a-input
                v-model:value="queryParams.ipaddr"
                allow-clear
                :maxlength="128"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.log.login.account')"
              name="userName"
            >
              <a-input
                v-model:value="queryParams.userName"
                allow-clear
                :maxlength="30"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.log.login.status')"
              name="status"
            >
              <a-select
                v-model:value="queryParams.status"
                allow-clear
                :options="dict.sysCommonStatus"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}</a-button
                >
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}</a-button
                >
              </a-space>
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.log.login.loginTime')"
              name="queryRangePicker"
            >
              <a-range-picker
                v-model:value="queryRangePicker"
                allow-clear
                bordered
                :show-time="{ format: 'HH:mm:ss' }"
                format="YYYY-MM-DD HH:mm:ss"
                value-format="x"
                style="width: 100%"
              ></a-range-picker>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button
            type="primary"
            :disabled="!tableState.selectedUserName"
            @click.prevent="fnUnlock()"
            v-perms:has="['system:log:login:unlock']"
          >
            <template #icon><UnlockOutlined /></template>
            {{ t('views.system.log.login.unlock') }}
          </a-button>
          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            @click.prevent="fnRecordDelete()"
            v-perms:has="['system:log:login:remove']"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>
          <a-button
            type="dashed"
            danger
            @click.prevent="fnCleanList()"
            v-perms:has="['system:log:login:remove']"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('views.system.log.operate.delAll') }}
          </a-button>
          <a-button
            type="dashed"
            @click.prevent="fnExportList()"
            v-perms:has="['system:log:login:export']"
          >
            <template #icon><ExportOutlined /></template>
            {{ t('common.export') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default"
                    >{{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle"
                    >{{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small"
                    >{{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="loginId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :scroll="{ x: tableColumns.length * 150 }"
        :pagination="tablePagination"
        :row-selection="{
          type: 'checkbox',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRows,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'status'">
            <DictTag :options="dict.sysCommonStatus" :value="record.status" />
          </template>
        </template>
      </a-table>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
